define([
    'text!../modules/translate/translate.html!strip'
  , 'css!../modules/translate/translate'
  ],
  function (source) {
    var response = {};
    response.data = source;
    response.callback = function () {
      var gadget = RenderJs.getSelfGadget(),
        i,
        list = RenderJs.GadgetIndex.getGadgetList(),
        current_gadget,
        recursive_gadgets = gadget.dom.find("[data-gadget]").not(".main-interactor"),
        len = recursive_gadgets.length,
        lang = $.fn.fauna.i18n_current_lang,
        switchIcon = function (id, icon) {
          var current_gadget, elem, gadget_to_translate;
          // not possible without, because JQM will not be done enhancing
          window.setTimeout(function(){
            current_gadget = RenderJs.GadgetIndex.getGadgetById(id),
            elem = current_gadget.dom.find(".setIcon .ui-icon");
            elem = $(".setIcon .ui-icon")
            if (elem.length > 0) {
            elem.removeClass()
              .addClass('ui-icon ui-shadow ui-icon-lang '+icon);
            }
          },50);
        },
        // set language
        set_lang = function (language) {
          var set_icon, elem, override = false, remote, popups, i, link;

          switch (language) {
            case "de-DE":
              set_icon = "DE";
            break;
            case "fr-FR":
              set_icon = "FR";
            break;
            default:
              set_icon = "EN";
            break;
          };

          // trigger create
          if (gadget.isEnhanced() === false) {
            $(document).trigger("render_enhance", {"gadget": gadget.dom });
          }

          if ( $.fn.fauna.i18n_current_lang !== language ) {
            override = true;
          }
          // translate all gadgets in the gadget list (dom available)
          for (i = 0; i < list.length; i += 1) {
            gadget_to_translate = list[i];

            if (gadget_to_translate.isEnhanced() === false || override ) {
              gadget_to_translate.dom
                .find(".t")
                  .i18n()
                  .end()
                // in JQM, we also need to update all widgets with "artificial"
                // text elements, such as selects
                // not nice: there must be a better way to do this!
                .find("select")
                  .selectmenu("refresh")
                  .end()
                .find("a.popup_trigger")
                  // exclude recursive gadgets
                  .filter(function(){
                    return !gadget_to_translate.dom.find("[data-gadget]").find(this).length;
                    }
                  )
                  .each(function(index, element){
                    remote = element.getAttribute('href').replace('#','');
                    $('#'+remote+'-popup').find('span.t, a.t, li.ui-li-divider').i18n();
                  }
                );
              gadget_to_translate.setEnhanced(true);
            }
          }
          $.fn.fauna.i18n_current_lang = language;
          switchIcon(gadget.id, set_icon);
        },
        // i18n handler
        lang = function (lang) {
          // init
          if ($.fn.fauna.i18n_set === undefined) {
            $.i18n.init({
              lng: 'en-EN',
              load: 'current',
              detectLngQS: 'lang',
              fallbackLng: false,
              resGetPath: 'lang/__lng__/__ns__.json',
              ns: 'gen'
              // , debug: true,
              // , useLocalStorage: true
              // , localStorageExpirationTime: 86400000 // in ms, default 1 week
            }, function () {
              set_lang($.i18n.lng());
            });
            $.fn.fauna.i18n_set = true;
          } else {
            set_lang(lang);
          }
        };

      // customize gadget
      if (gadget.self !== undefined) {
        for (key in gadget.self) {
          if (gadget.self.hasOwnProperty(key)) {
            gadget.dom.find(key).attr(gadget.self[key][0],gadget.self[key][1]);
          }
        }
      }

      recursive_gadgets.each(function (i) {
        var passJSON = gadget[$(this).attr('id')],
          string, new_string,
          current_id = $(this).attr('id'),
          new_id = current_id+"__"+gadget.dom.attr('id');

        // pass on JSON if present BEFORE modifying gadget-id
        if (passJSON !== undefined) {
          $(this).attr('data-gadget-property','{"self":'+JSON.stringify(passJSON)+'}');
        }

        // dynamic gadget-id
        $(this).attr('id', new_id);
      });

      // does not work when navigating between multiple pages
      // moved to docReady
      RenderJs.bindReady(function () {
        var current_lang = $.fn.fauna.i18n_current_lang;
        lang(current_lang);
      });

    $(document).ready(function() {
      // fallback for old devices which cannot load <style> css
      // var gadget = RenderJs.getSelfGadget();

      $(this)
          .filter(function() { return $(this).jqmData("i18n") !== true; })
          .jqmData('i18n',true)
          .on('click', '.change_language', function(e) {
            var new_language = $(this).attr('href').replace('?lang=','');
            e.preventDefault();
            e.stopPropagation();
            $('.all_popups').popup( "close" );
            // switch to new language
            $.i18n.setLng(new_language, function() {
              // switch to new language
              lang(new_language);
            });
          });

//         // fallback for old devices which cannot load <style> css
//         if (gadget.dom.find(".el").css('width') !== "1px") {
//           require(['text!../css/translate.css'], function (t) {
//             var x = '<style>'+t+'</style>';
//             // why does this not updat the DOM, too?
//             gadget.dom.append(x);
//           });
//         }
      });
    };
  // return response object
  return response;
  }
);